include:
  - project: container-email/resources/gitlab-templates
    ref: main
    file: shellcheck.yml

stages:
- lint
- precheck
- build
- deploy

check-ver:
  image: node
  stage: precheck
  script: 
    - |
        if [ ! -z "$BUILDVER" ]; then
          V="$BUILDVER"
        else
          V="$(npm exec --no-update-notifier --yes -- url-file-version --url https://ftp.denx.de/pub/u-boot/ --prefix u-boot --ending .tar.bz2 -b)"
        fi
        F="u-boot-blob-$V.tar.bz2"
        if ! wget -S --spider "${CI_API_V4_URL}/projects/${CI_PROJECT_ID}/packages/generic/uboot/$V/$F"; then
          echo "Need to build u-boot $V"
          echo "$V" > buildit
        else
          echo "u-boot package is up to date"
          cat /dev/null > buildit
        fi
        if [ ! -z "$BUILDIT" ]; then echo "$V" > buildit && echo "Forcing build"; fi
  artifacts:
    paths:
      - buildit
    expire_in: 1 day

build-uboot:
  image: registry.gitlab.com/raspi-alpine/crosscompile-base/main
  stage: build
  script: 
    - |
        if [ -s buildit ]; then
        V="$(cat buildit)"
          echo "Building version: $V"
          CI_UBOOT="$V" ./build-uboot.sh
        else
          echo "Not building, already up to date"
        fi
  artifacts:
    paths:
      - deploy
    expire_in: 1 week
  dependencies: 
    - check-ver

deploy-uboot:
  image: alpine
  stage: deploy
  script: 
    - |
      if [ -s buildit ]; then
        apk add --no-cache curl
        cd deploy || exit 1
        V="$(cat version)"
        F="$(cat name)"
        curl --header "JOB-TOKEN: $CI_JOB_TOKEN" --upload-file "$F" "${CI_API_V4_URL}/projects/${CI_PROJECT_ID}/packages/generic/uboot/$V/$F"
        sha256sum "$F" > "$F".sha256
        curl --header "JOB-TOKEN: $CI_JOB_TOKEN" --upload-file "$F".sha256 "${CI_API_V4_URL}/projects/${CI_PROJECT_ID}/packages/generic/uboot/$V/$F.sha256"
      else
        echo "Not deploying, already up to date"
      fi
  dependencies: 
    - build-uboot
    - check-ver
  only:
    - main

shellcheck:
  allow_failure: true
